package de.limited_dev.lil_judd.features;

import de.limited_dev.lil_judd.Main;
import de.limited_dev.lil_judd.features.storage.GuildTimePlannerStorage;
import de.limited_dev.lil_judd.util.EmbeddedMessageHelper;
import de.limited_dev.lil_judd.util.Logger;
import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.entities.Guild;

import java.time.Duration;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class TimePlanner {
    private static final GuildTimePlannerStorage gtps = GuildTimePlannerStorage.getInstance();
    private static final Logger lgr = Main.getLgr();

    public static GuildTimePlannerStorage getGtps() {
        return gtps;
    }

    public static void registerMessageThread(){
        // get the current ZonedDateTime of your TimeZone
        ZonedDateTime now = ZonedDateTime.now(ZoneId.of("Europe/Berlin"));//.withHour(8).withMinute(0);

        // set the ZonedDateTime of the first lesson at 8:05
        //ZonedDateTime nextNotifyDay = now.plusDays(DayUtil.getDelay(now.getDayOfWeek().name()));
        ZonedDateTime nextNotifyDay = now.plusSeconds(10);
        lgr.info(now.getDayOfMonth() + "");

        //lgr.info(now.getDayOfWeek().name() + " " + nextNotifyDay.getDayOfWeek().name());

        // if it's already past the time (in this case 8:05) the first lesson will be scheduled for the next day
        if (now.compareTo(nextNotifyDay) > 0) {
            nextNotifyDay = nextNotifyDay.plusDays(7);
            lgr.info("See you next week");
        }

        // duration between now and the beginning of the next first lesson
        Duration timeUntilNextNotification = Duration.between(now, nextNotifyDay);
        // in seconds
        long initialDelayUntilNextNotification = timeUntilNextNotification.getSeconds();

        lgr.info("Duration: " + initialDelayUntilNextNotification);

        // schedules the reminder at a fixed rate of one day
        ScheduledExecutorService schedulerFirstLesson = Executors.newScheduledThreadPool(1);
        schedulerFirstLesson.scheduleAtFixedRate(() -> {
                    // send a message

                    String msg = "<Msg Content>";
                    JDA jda = Main.getJda();
                    Set<Long> gs = gtps.guildsWithPlanner.keySet();
                    lgr.info(gs.toString());
                    for (Long l : gs) {
                        //guild.getDefaultChannel().sendMessage(message).queue();
                        //jda.getGuildById(l).getTextChannelById(gtps.getChannelID(l)).sendMessage("").queue();
                        EmbeddedMessageHelper.sendSimpleOneLiner(jda.getGuildById(l), gtps.guildsWithPlanner.get(l), "You got time?", "Ain't nobody got time for that?", null);
                        lgr.info("Send Code to Server " + jda.getGuildById(l).getName());
                    }
                    lgr.info("Send Push Notification for time Management");
                },
                initialDelayUntilNextNotification,
                TimeUnit.SECONDS.toSeconds(10),//TimeUnit.DAYS.toSeconds(7),
                TimeUnit.SECONDS);

    }
}
